List<ResellerModel> resellerFromJson(dynamic str) =>
    List<ResellerModel>.from(str.map((x) => ResellerModel.fromJson(x)));

class ResellerModel {
  late final String sId;
  late final String userId;
  late final String orderId;
  late final int paymentStatus;
  late final double resellerPrice;
  late final double price;
  late final double margin;
  late final String description;
  late final DateTime? paymentDate;
  late final bool status;
  ResellerModel(
      {required this.sId,
      required this.userId,
      required this.orderId,
      required this.paymentStatus,
      required this.resellerPrice,
      required this.price,
      required this.margin,
      required this.description,
      required this.paymentDate,
      required this.status});
  ResellerModel.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    userId = json['userId'];
    orderId = json['orderId'];
    paymentStatus = json['paymentStatus'];
    resellerPrice = json['resellerPrice'].toDouble();
    price = json['price'].toDouble();
    margin = json['margin'].toDouble();
    description = json['description'];
    paymentDate = json['paymentDate'] != null
        ? DateTime.parse(json['paymentDate'])
        : null;
    status = json['status'];
  }
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['_id'] = this.sId;
    data['userId'] = this.userId;
    data['orderId'] = this.orderId;
    data['paymentStatus'] = this.paymentStatus;
    data['resellerPrice'] = this.resellerPrice;
    data['price'] = this.price;
    data['margin'] = this.margin;
    data['description'] = this.description;
    data['paymentDate'] = this.paymentDate;
    data['status'] = this.status;
    return data;
  }
}
