import 'package:b2b_graphql_package/GraphQLConfiguration.dart';
import 'package:b2b_graphql_package/modules/reseller/reseller_model.dart';
import 'package:graphql_flutter/graphql_flutter.dart';

class ResellerRepo {
  var graphQLConfiguration;
  List<ResellerModel> resellerOutput = [];
  var resellerCount = 0;

  ResellerRepo() {
    graphQLConfiguration = GraphQLConfiguration();
  }
  Future getResellerByUserIdWithPagination(
      String userId, int limit, int pageNo) async {
    GraphQLClient _client = graphQLConfiguration.clientToQuery();
    var resellerGql = """
                    query getResellerByUserIdWithPagination(\$userId: String, \$limit: Int, \$pageNo: Int) {
                      getResellerByUserIdWithPagination(userId: \$userId, limit: \$limit, pageNo: \$pageNo) {
                         _id
                          userId
                          orderId
                          paymentStatus
                          resellerPrice
                          price
                          margin
                          description
                          paymentDate
                          status
                      }
                    }
                      """;
    var variable = {"userId": userId, "limit": limit, "pageNo": pageNo};
    QueryResult result = await _client.query(QueryOptions(
        document: gql(resellerGql),
        variables: variable,
        fetchPolicy: FetchPolicy.networkOnly));
    resellerOutput = [];
    print(result);
    if (!result.hasException) {
      var resellerResult = result.data!['getResellerByUserIdWithPagination'];
      if (resellerResult != null && resellerResult.length > 0) {
        resellerOutput = resellerFromJson(resellerResult);
      }
    }
    return resellerOutput;
  }

  Future getResellerCount(String userId) async {
    GraphQLClient _client = graphQLConfiguration.clientToQuery();
    var resellerCountGql = """
                      query resellerCountByUserId(\$userId: String) {
                        resellerCountByUserId(userId: \$userId) 
                      }
                           """;
    var variable = {"userId": userId};
    QueryResult result = await _client.query(QueryOptions(
        document: gql(resellerCountGql),
        variables: variable,
        fetchPolicy: FetchPolicy.networkOnly));
    if (!result.hasException) {
      var countResult = result.data!['resellerCountByUserId'];

      if (countResult != null) {
        resellerCount = countResult;
      }
    }
    return resellerCount;
  }
}
