List<AllWishlistForVerfication> allWishListVerificationFromJson(dynamic str) =>
    List<AllWishlistForVerfication>.from(
        str.map((x) => AllWishlistForVerfication.fromJson(x)));

class AllWishlistForVerfication {
  late final String productId;
  late final String sTypename;

  AllWishlistForVerfication({required this.productId, required this.sTypename});

  AllWishlistForVerfication.fromJson(Map<String, dynamic> json) {
    productId = json['productId'];
    sTypename = json['__typename'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['productId'] = this.productId;
    data['__typename'] = this.sTypename;
    return data;
  }
}

List<AllWishlist> allWishListFromJson(dynamic str) =>
    List<AllWishlist>.from(str.map((x) => AllWishlist.fromJson(x)));

class AllWishlist {
  late final String sId;
  late final String? packId;
  late final String? setId;
  late final String? productId;
  late final String? packImage;
  late final String? packName;
  late final int? setPrice;
  late final String? sTypename;

  AllWishlist(
      {required this.sId,
      required this.packId,
      required this.setId,
      required this.productId,
      required this.packImage,
      required this.packName,
      required this.setPrice,
      required this.sTypename});

  AllWishlist.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    packId = json['packId'];
    setId = json['setId'];
    productId = json['productId'];
    packImage = json['packImage'];
    packName = json['packName'];
    setPrice = json['setPrice'];
    sTypename = json['__typename'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['_id'] = this.sId;
    data['packId'] = this.packId;
    data['setId'] = this.setId;
    data['productId'] = this.productId;
    data['packImage'] = this.packImage;
    data['packName'] = this.packName;
    data['setPrice'] = this.setPrice;
    data['__typename'] = this.sTypename;
    return data;
  }
}

AddWishlistByCart wishlistByCartFromJson(dynamic str) =>
    (AddWishlistByCart.fromJson(str));

class AddWishlistByCart {
  late final bool isExists;
  late final String sTypename;

  AddWishlistByCart({required this.isExists, required this.sTypename});

  AddWishlistByCart.fromJson(Map<String, dynamic> json) {
    isExists = json['isExists'];
    sTypename = json['__typename'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['isExists'] = this.isExists;
    data['__typename'] = this.sTypename;
    return data;
  }
}

List<AllWishlistWithProduct> allWishListWithProductFromJson(dynamic str) =>
    List<AllWishlistWithProduct>.from(
        str.map((x) => AllWishlistWithProduct.fromJson(x)));

List<WishlistImage> WishlistImageFromJson(dynamic str) =>
    List<WishlistImage>.from(str.map((x) => WishlistImage.fromJson(x)));

class AllWishlistWithProduct {
  late final String sId;
  late final String? name;
  late final String? description;
  late final String? type;
  late final int? moq;
  late final bool? isOutofstock;
  late final bool? isMultiple;
  late final String? imageId;
  late final WishlistPrice? price;
  late final List<WishlistImage>? images;

  AllWishlistWithProduct(
      {required this.sId,
      required this.name,
      required this.description,
      required this.type,
      required this.moq,
      required this.isOutofstock,
      required this.isMultiple,
      required this.imageId,
      required this.price,
      required this.images});

  AllWishlistWithProduct.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    name = json['name'];
    description = json['description'];
    type = json['type'];
    moq = json['moq'];
    isOutofstock = json['isOutofstock'];
    isMultiple = json['isMultiple'];
    imageId = json['imageId'];
    price = WishlistPrice.fromJson(json['price']);
    images = WishlistImageFromJson(json['images']);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['_id'] = this.sId;
    data['name'] = this.name;
    data['description'] = this.description;
    data['type'] = this.type;
    data['moq'] = this.moq;
    data['isOutofstock'] = this.isOutofstock;
    data['isMultiple'] = this.isMultiple;
    data['imageId'] = this.imageId;
    data['price'] = this.price;
    data['images'] = this.images;
    return data;
  }
}

class WishlistImage {
  late final String? imageName;
  late final int? position;

  WishlistImage({required this.imageName, required this.position});
  WishlistImage.fromJson(Map<String, dynamic> json) {
    imageName = json['imageName'];
    position = json['position'];
  }
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['imageName'] = this.imageName;
    data['position'] = this.position;
    return data;
  }
}

class WishlistPrice {
  late final double? sellingPrice;
  late final double? mrp;
  late final double? discount;
  late final double? minPrice;
  late final double? maxPrice;
  late final String? type;
  late final bool? isSamePrice;
  WishlistPrice(
      {required this.sellingPrice,
      required this.mrp,
      required this.discount,
      required this.minPrice,
      required this.maxPrice,
      required this.type,
      required this.isSamePrice});
  WishlistPrice.fromJson(Map<String, dynamic> json) {
    sellingPrice =
        json['sellingPrice'] != null ? json['sellingPrice'].toDouble() : 0.0;
    mrp = json['mrp'] != null ? json['mrp'].toDouble() : 0.0;
    discount = json['discount'] != null ? json['discount'].toDouble() : 0.0;
    minPrice = json['minPrice'] != null ? json['minPrice'].toDouble() : 0.0;
    maxPrice = json['maxPrice'] != null ? json['maxPrice'].toDouble() : 0.0;
    type = json['type'];
    isSamePrice = json['isSamePrice'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['sellingPrice'] = this.sellingPrice;
    data['mrp'] = this.mrp;
    data['discount'] = this.discount;
    data['minPrice'] = this.minPrice;
    data['maxPrice'] = this.maxPrice;
    data['type'] = this.type;
    data['isSamePrice'] = this.isSamePrice;
    return data;
  }
}

class SingleWishlist {
  late final String? sId;
  late final String? productId;

  SingleWishlist({required this.sId, required this.productId});
  SingleWishlist.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    productId = json['productId'];
  }
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['_id'] = this.sId;
    data['productId'] = this.productId;
    return data;
  }
}
