import 'package:b2b_graphql_package/modules/wishlist/wishlist_model.dart';
import 'package:graphql_flutter/graphql_flutter.dart';

import '../../GraphQLConfiguration.dart';

class WishListRepo {
  var graphQLConfiguration;

  WishListRepo() {
    graphQLConfiguration = GraphQLConfiguration();
  }
  var allWishList = [];
  var wishListCheck = false;
  Future<bool> updateWishlist(String userId, String packId) async {
    String wishlistGql =
        """mutation changeWishlist(\$userId: String, \$packId: String) {
              changeWishlist(userId: \$userId, packId: \$packId) {
                _id
                __typename
              }
            }""";
    GraphQLConfiguration graphQLConfiguration = GraphQLConfiguration();
    GraphQLClient _client = graphQLConfiguration.clientToQuery();
    final vble = {"packId": packId, "userId": userId};
    QueryResult result = await _client.mutate(
      MutationOptions(
        document: gql(wishlistGql),
        variables: vble,
      ),
    );
    if (!result.hasException) {
      var wishlist = result.data!['changeWishlist'];
      if (wishlist != null && wishlist["_id"] != null) {
        return true;
      } else {
        return true;
      }
    }
    return false;
  }

  Future getWishListForVarification(String userId) async {
    GraphQLClient _client = graphQLConfiguration.clientToQuery();

    var orderListGql = """ 
             query getAllWishlistForVerfication(\$userId: String) {
            getAllWishlistForVerfication(userId: \$userId) {
              packId
              __typename
            }
          }
            """;

    final vble = {"userId": userId};
    QueryResult result = await _client.query(QueryOptions(
      document: gql(orderListGql),
      variables: vble,
      fetchPolicy: FetchPolicy.networkOnly,
    ));

    if (!result.hasException) {
      var allWishList = result.data!['getAllWishlistForVerfication'];

      if (allWishList != null && allWishList.length > 0) {
        allWishList = allWishListVerificationFromJson(allWishList);
        return allWishList;
      }
    }
    return allWishList;
  }

  Future getAllWishList(String userId) async {
    GraphQLClient _client = graphQLConfiguration.clientToQuery();

    var orderListGql = """ 
            query getAllWishlist(\$userId: String) {
            getAllWishlist(userId: \$userId) {
              _id
              packId
              setId
              packImage
              packName
              setPrice
              __typename
            }
          }
            """;

    final vble = {"userId": userId};
    QueryResult result = await _client.query(QueryOptions(
      document: gql(orderListGql),
      variables: vble,
      fetchPolicy: FetchPolicy.networkOnly,
    ));
    if (!result.hasException) {
      var allWishList = result.data!['getAllWishlist'];

      if (allWishList != null && allWishList.length > 0) {
        allWishList = allWishListFromJson(allWishList);
        return allWishList;
      }
    }
    return allWishList;
  }

  Future<bool> removeWishlist(String userId, String wishlistId) async {
    String wishlistGql =
        """mutation removeWishlist(\$userId: String, \$wishlistId: String) {
          removeWishlist(userId: \$userId, wishlistId: \$wishlistId) {
            _id
            __typename
          }
        }""";
    GraphQLConfiguration graphQLConfiguration = GraphQLConfiguration();
    GraphQLClient _client = graphQLConfiguration.clientToQuery();
    final vble = {"userId": userId, "wishlistId": wishlistId};
    QueryResult result = await _client.mutate(
      MutationOptions(
        document: gql(wishlistGql),
        variables: vble,
      ),
    );
    if (!result.hasException) {
      var removeWishlist = result.data!['removeWishlist'];
      if (removeWishlist != null && removeWishlist["_id"] != null) {
        return true;
      } else {
        return true;
      }
    }
    return false;
  }

  var wishListByCart;
  Future addWishListByCart(String userId, String packId) async {
    String wishlistGql =
        """mutation addWishlistByCart(\$packId: String, \$setId: String, \$userId: String) {
          addWishlistByCart(packId: \$packId, setId: \$setId, userId: \$userId) {
            isExists
            __typename
          }
        }""";
    GraphQLConfiguration graphQLConfiguration = GraphQLConfiguration();
    GraphQLClient _client = graphQLConfiguration.clientToQuery();
    final vble = {"packId": packId, "userId": userId};
    QueryResult result = await _client.mutate(
      MutationOptions(
        document: gql(wishlistGql),
        variables: vble,
      ),
    );
    if (!result.hasException) {
      var wishlist = result.data!['addWishlistByCart'];
      if (wishlist != null) {
        wishListByCart = wishlistByCartFromJson(wishlist);
      }
    }
    return wishListByCart;
  }

  Future checkProductWishList(String userId, String packId) async {
    GraphQLClient _client = graphQLConfiguration.clientToQuery();

    var wishListCheckGql = """ 
                      query checkProductWishlist(\$userId: String, \$packId: String) {
              checkProductWishlist(userId: \$userId, packId: \$packId)
            }
            """;

    final vble = {"userId": userId, "packId": packId};
    QueryResult result = await _client.query(QueryOptions(
      document: gql(wishListCheckGql),
      variables: vble,
      fetchPolicy: FetchPolicy.networkOnly,
    ));

    if (!result.hasException) {
      var productWishlistCheck = result.data!['checkProductWishlist'];

      if (productWishlistCheck != null) {
        wishListCheck = productWishlistCheck;
        return wishListCheck;
      }
    }
    return wishListCheck;
  }

  Future changeProductWishlist(String userId, String productId) async {
    GraphQLClient _client = graphQLConfiguration.clientToQuery();

    var changeProductWishlistGql = """ 
                      query checkSingleProductWishlist(\$userId: String, \$productId: String) {
              checkSingleProductWishlist(userId: \$userId, productId: \$productId) {
                _id
              }
            }
            """;

    final vble = {"userId": userId, "productId": productId};
    QueryResult result = await _client.query(QueryOptions(
      document: gql(changeProductWishlistGql),
      variables: vble,
      fetchPolicy: FetchPolicy.networkOnly,
    ));

    if (!result.hasException) {
      var productWishlistCheck = result.data!['checkSingleProductWishlist'];

      if (productWishlistCheck != null) {
        return true;
      }
    }
    return false;
  }

  Future getAllProductWishlistForVerification(String userId) async {
    GraphQLClient _client = graphQLConfiguration.clientToQuery();

    var orderListGql = """ 
             query getAllProductWishlistForVerification(\$userId: String) {
            getAllProductWishlistForVerification(userId: \$userId) {
              productId
              __typename
            }
          }
            """;

    final vble = {"userId": userId};
    QueryResult result = await _client.query(QueryOptions(
      document: gql(orderListGql),
      variables: vble,
      fetchPolicy: FetchPolicy.networkOnly,
    ));

    if (!result.hasException) {
      var allWishList = result.data!['getAllProductWishlistForVerification'];

      if (allWishList != null && allWishList.length > 0) {
        allWishList = allWishListVerificationFromJson(allWishList);
        return allWishList;
      }
    }
    return allWishList;
  }

  Future getAllWishListWithProduct(String userId) async {
    GraphQLClient _client = graphQLConfiguration.clientToQuery();

    var orderListGql = """ 
           query getAllWishlistWithProduct(\$userId: String) {
    getAllWishlistWithProduct(userId: \$userId) {
        _id
        name
        description
        type
        moq
        isOutofstock
        isMultiple
        imageId
        price {
            sellingPrice
            mrp
            discount
            minPrice
            maxPrice
            type
            isSamePrice
        }
        images {
          imageName
          position
        }
    }
}
            """;

    final vble = {"userId": userId};
    QueryResult result = await _client.query(QueryOptions(
      document: gql(orderListGql),
      variables: vble,
      fetchPolicy: FetchPolicy.networkOnly,
    ));
    if (!result.hasException) {
      var allWishList = result.data!['getAllWishlistWithProduct'];
      if (allWishList != null && allWishList.length > 0) {
        allWishList = allWishListWithProductFromJson(allWishList);
        return allWishList;
      }
    }
    return allWishList;
  }

  Future getSingleProductWishlist(String userId, String productId) async {
    GraphQLClient _client = graphQLConfiguration.clientToQuery();
    var orderListGql = """ 
             query getSingleProductWishlist(\$userId: String, \$productId: String) {
            getSingleProductWishlist(userId: \$userId, productId: \$productId) {
              productId
              _id
            }
          }
            """;

    final vble = {"userId": userId, "productId": productId};
    QueryResult result = await _client.query(QueryOptions(
      document: gql(orderListGql),
      variables: vble,
      fetchPolicy: FetchPolicy.networkOnly,
    ));
    if (!result.hasException) {
      var allWishList = result.data!['getSingleProductWishlist'];

      if (allWishList != null && allWishList.length > 0) {
        allWishList = SingleWishlist.fromJson(allWishList);
        return allWishList != null ? true : false;
      }
    }
    return false;
  }

  Future<bool> removeWishlistByProductId(
      String userId, String productId) async {
    String wishlistGql =
        """mutation removeWishlistByProductId(\$userId: String, \$productId: String) {
          removeWishlistByProductId(userId: \$userId, productId: \$productId) {
            _id
          }
        }""";
    GraphQLConfiguration graphQLConfiguration = GraphQLConfiguration();
    GraphQLClient _client = graphQLConfiguration.clientToQuery();
    final vble = {"userId": userId, "productId": productId};
    QueryResult result = await _client.mutate(
      MutationOptions(
        document: gql(wishlistGql),
        variables: vble,
      ),
    );
    if (!result.hasException) {
      var removeWishlist = result.data!['removeWishlistByProductId'];
      if (removeWishlist != null && removeWishlist["_id"] != null) {
        return true;
      } else {
        return true;
      }
    }
    return false;
  }
}
